function [keys, vals, err] = keysvals(varargin)
% e.g.:
% [keys vals err] = keysvals(varargin); error(err)

% Part of PFCMP version 2.5.41, an extension to the PSIGNIFIT toolbox for MATLAB versions 5 and up.
% The license and NO WARRANTY statement for PSIGNIFIT also applies to this release - see psych_legal.m
% Copyright (c) J.Hill 2002.
% mailto:psignifit@bootstrap-software.org
% http://www.bootstrap-software.org/psignifit/

err = '';
if length(varargin) == 1
	if iscell(varargin{1}), varargin = varargin{1}; end
end
keys = varargin(1:2:end);
vals = varargin(2:2:end);
if length(keys) ~= length(vals)
	err = 'arguments must come in key/value pairs';
elseif ~iscellstr(keys)
	err = 'key arguments must be strings';
end
if nargout < 3, error(err), end
